
function flatten (parent, data = [], menusRaw = []) {
  console.log(parent)
  return data.reduce((acc, { name, children }) => {
    const menu = menusRaw.filter(x => x.Url === name)[0]
    if (!menu) return acc

    const title = menu.MenuName
    const item = { name, title, parent }

    if (children && children.length) {
      const p = parent.concat({ name, title })
      return acc.concat(item, flatten(p, children, menusRaw))
    }

    return acc.concat(item)
  }, [])
}

export default {
  state: {
    menusRaw: [{
      MenuId: '1',
      MenuName: '菜单1',
      Icon: 'menu1',
      FatherID: '-1',
      Url: 'system',
      IsShow: 1
    }, {
      MenuId: '2',
      MenuName: '菜单1-1',
      Icon: 'menu2',
      FatherID: '1',
      Url: 'systemSet',
      IsShow: 1
    }, {
      MenuId: '3',
      MenuName: '菜单1-1-1',
      Icon: '',
      FatherID: '2',
      Url: 'userManager',
      IsShow: 1
    }],
    menus: [],
    breadcrumb: [],
  },
  mutations: {
    updateBread (state, { routerData, name }) {
      // 扁平 routerData
      // 同时构造出 含有 title 的 parent 数据
      const routeList = flatten([], routerData, state.menusRaw)

      // 过滤出与 name 相同的 route 节点
      const currentRoute = routeList.filter(x => x.name === name)[0]

      // console.log(currentRoute, routeList, routerData, state.menusRaw)

      // 获取 面包屑
      state.breadcrumb = currentRoute.parent
    }
  }
}
